---
title: 'ARIA: switch role'
slug: Web/Accessibility/ARIA/Roles/Switch_role
tags:
  - ARIA
  - ARIA Role
  - Accessibility
  - On/Off
  - Reference
  - Switch
  - a11y
  - toggle
---
<div>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</div>

<p><span class="seoSummary">The ARIA <strong><code>switch</code></strong> role is functionally identical to the <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/checkbox_role">checkbox</a> role, except that instead of representing "checked" and "unchecked" states, which are fairly generic in meaning, the <code>switch</code> role represents the states "on" and "off."</span></p>

<p>This example creates a widget and assigns the ARIA <code>switch</code> role to it.</p>

<pre>&lt;button type="button" role="switch" aria-checked="true"
    id="speakerPower" class="switch"&gt;
    &lt;span&gt;off&lt;/span&gt;
    &lt;span&gt;on&lt;/span&gt;
&lt;/button&gt;
&lt;label for="speakerPower" class="switch"&gt;Speaker power&lt;/label&gt;</pre>

<h2 id="Description">Description</h2>

<p>The ARIA <strong><code>switch</code></strong> role is identical to the <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/checkbox_role">checkbox</a> role, except instead of being "checked" or "unchecked", it is either "on" and "off."  Like the <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/checkbox_role">checkbox</a> role, the <code>aria-checked</code> attribute is required. The two possible values are <code>true</code> and <code>false</code>. Unlike a <code>&lt;checkbox&gt;</code> or <code>role="checkbox"</code>, there is no <code>indeterminate</code> or <code>mixed</code> state. The <code>switch</code> role does not support the value <code>mixed</code> for the <code>aria-checked</code> attribute; assigning a value of <code>mixed</code> to a <code>switch</code> instead sets the value to <code>false</code>.</p>

<p>Assistive technologies may choose to represent <code>switch</code> widgets with a specialized presentation to reflect the notion of an on/off switch.</p>

<p>Since a switch is an interactive control, it must be focusable and keyboard accessible. If the role is applied to a non-focusable element, use the <code>tabindex</code> attribute to change this. The expected keyboard shortcut for toggling the value of a switch is the <kbd>Space</kbd> key. The developer is required to change the value of the <code>aria-checked</code> attribute dynamically when the switch is toggled.</p>

<h3 class="highlight-spanned" id="Associated_ARIA_roles_states_and_properties"><span class="highlight-span">Associated ARIA roles, states, and properties</span></h3>

<dl>
 <dt><code>aria-checked</code> attribute</dt>
 <dd>The <code>aria-checked</code> attribute is <strong>required</strong> when using the <code>switch</code> role, as it represents the current state of the widget that the <code>switch</code> role is applied to. A value of <code>true</code> represents the "on" state; <code>false</code> represents the "off" state; a value of <code>mixed</code> is not supported by the switch role, and is treated as <code>false</code>. The default value is <code>false</code>.</dd>
 <dt><code>aria-readonly</code> attribute</dt>
 <dd>The <code>aria-readonly</code> attribute is supported by the <code>switch</code> role. It indicates whether the widget's state is editable by the user. A value of <code>false</code> means that the user <em>can</em> change the widget's state; a value of <code>true</code> means that the user <em>cannot</em> change the widget's state. The default value is <code>false</code>.</dd>
</dl>

<h3 class="highlight-spanned" id="Required_JavaScript_features"><span class="highlight-span">Required JavaScript features</span></h3>

<dl>
 <dt>Handler for click events</dt>
 <dd>When the user clicks on the switch widget, a <a href="/en-US/docs/Web/Events/click">click event </a>is fired, which must be handled in order to change the state of the widget.</dd>
 <dt>Changing the <code>aria-checked</code> attribute</dt>
 <dd>When a click event is fired on the switch widget, the handler must change the value of the <code>aria-checked</code> attribute from <code>true</code> to <code>false</code>, or vice versa.</dd>
</dl>

<h2 id="Possible_effects_on_user_agents_and_assistive_technology">Possible effects on user agents and assistive technology</h2>

<p>When the <code>switch</code> role is added to an element, the {{Glossary("user agent")}} handles it like this:</p>

<ul>
 <li>The element is exposed to the system's accessibility infrastructure as having the <code>switch</code> role.</li>
 <li>When the <code>aria-checked</code> attribute's value changes, an accessible event is fired using the system's accessibility API if one is available and it supports the <code>switch</code> role.</li>
 <li>All elements that are descendants of an element with the <code>switch</code> role applied to it are automatically assigned role <code>presentation</code>. This prevents elements that are used to construct the switch  from being interacted with individually by assistive technologies. Text in these elements remains visible to the user agent and may be read or otherwise delivered to the user, unless it's expressly hidden using {{cssxref("display", "display: none")}} or <code>aria-hidden="true"</code>.</li>
</ul>

<p>The assistive technology, if it supports the <code>switch</code> role, responds by doing the following:</p>

<ul>
 <li>Screen readers should announce the element as a switch, optionally providing instructions as to how to activate the switch.</li>
</ul>

<div class="note">
<p>There are varying opinions on how assistive technologies should handle this role; the above is a suggested practice and may differ from other sources.</p>
</div>

<h2 id="Examples">Examples</h2>

<p>The following examples should help you understand how to apply and use the <code>switch</code> role.</p>

<h3 id="Adding_the_switch_role_in_ARIA">Adding the switch role in ARIA</h3>

<p>This simple example just creates a widget and assigns the ARIA <code>switch</code> role to it. The button is styled with an appearance reminiscent of an on/off power switch.</p>

<h4 id="HTML">HTML</h4>

<p>The HTML is fairly simple here. The switch is implemented as a {{HTMLElement("button")}} element which is initially checked courtesy of its <code>aria-checked</code> attribute being set to <code>"true"</code>. The switch has two child elements containing the "off" and "on" labels and is followed by a {{HTMLElement("label")}} identifying the switch.</p>

<pre class="brush: html">&lt;button role="switch" aria-checked="true"
      id="speakerPower" class="switch"&gt;
  &lt;span&gt;off&lt;/span&gt;
  &lt;span&gt;on&lt;/span&gt;
&lt;/button&gt;
&lt;label for="speakerPower" class="switch"&gt;Speaker power&lt;/label&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<p>This JavaScript code defines and applies a function to handle click events on switch widgets. The function changes the <code>aria-checked</code> attribute from <code>true</code> to <code>false</code>, or vice versa.</p>

<pre class="brush: js">document.querySelectorAll(".switch").forEach(function(theSwitch) {
  theSwitch.addEventListener("click", handleClickEvent, false);
});

function handleClickEvent(evt) {
  let el = evt.target;

  if (el.getAttribute("aria-checked") == "true") {
      el.setAttribute("aria-checked", "false");
  } else {
      el.setAttribute("aria-checked", "true");
  }
}</pre>

<h4 id="CSS">CSS</h4>

<p>The purpose of the CSS is to establish a look and feel for the switch that's reminiscent of the power switch paradigm.</p>

<pre class="brush: css">button.switch {
  margin: 0;
  padding: 0;
  width: 70px;
  height: 26px;
  border: 2px solid black;
  display: inline-block;
  margin-right: 0.25em;
  line-height: 20px;
  vertical-align: middle;
  text-align: center;
  font: 12px "Open Sans", "Arial", serif;
}

button.switch span {
  padding: 0 4px;
  pointer-events: none;
}

[role="switch"][aria-checked="false"] :first-child,
[role="switch"][aria-checked="true"] :last-child {
  background: #262;
  color: #eef;
}

[role="switch"][aria-checked="false"] :last-child,
[role="switch"][aria-checked="true"] :first-child {
  color: #bbd;
}

label.switch {
  font: 16px "Open Sans", "Arial", sans-serif;
  line-height: 20px;
  user-select: none;
  vertical-align: middle;
  -moz-user-select: none;
  -ms-user-select: none;
  -webkit-user-select: none;
  -o-user-select: none;
}</pre>

<p>The most interesting part is probably the use of attribute selectors and the {{cssxref(":first-child")}} and {{cssxref(":last-child")}} pseudo-classes to do all the heavy lifting of changing the appearance of the switch based on whether it's on or off.</p>

<h4 id="Result">Result</h4>

<p>The result looks like this:</p>

<p>{{EmbedLiveSample("Adding_the_switch_role_in_ARIA", 600, 40)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ARIA', '#switch')}}</td>
   <td>{{Spec2('ARIA')}}</td>
   <td>Defines ARIA in general along with all roles, properties, and so forth.</td>
  </tr>
  <tr>
   <td>{{SpecName('ARIA in HTML', '#index-aria-switch')}}</td>
   <td>{{Spec2('ARIA in HTML')}}</td>
   <td>Describes how ARIA's features integrate into HTML.</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_checkbox_role">ARIA: checkbox role</a></li>
 <li><code><a href="en-US/docs/Web/HTML/Element/input/checkbox">&lt;input type="checkbox"&gt;</a></code></li>
</ul>
